
local sWidth, sHeight = guiGetScreenSize()

local zoneName = {}
local areaName = ""
local timeText = 5000 -- Don't change it
local scale = 2.3
local vehicle, currentZone, tickStart
zoneName["currentArea"] = {}

addEvent( "setZoneNameVisible:Server", true )

addEventHandler( "onClientResourceStart", resourceRoot,
	function ()
		setPlayerHudComponentVisible("area_name", false)
		addEventHandler( "onClientRender", root, getCurrentAreaNameOnRender )
		setElementData(localPlayer, "isZoneNameVisible", true)
		setElementData(localPlayer, "isZoneNameInScreen", false)
	end
)

local disabledVehicles = {
	[548]=true, [425]=true, [417]=true, [487]=true, [488]=true, [497]=true,
	[563]=true, [447]=true, [469]=true, [592]=true, [577]=true, [511]=true,
	[512]=true, [593]=true, [520]=true, [553]=true, [476]=true, [519]=true,
	[460]=true, [513]=true, [464]=true, [465]=true, [501]=true
}
 
function getCurrentAreaNameOnRender()
	if not isPlayerHudComponentVisible("area_name") then
		local x,y,z = getElementPosition(localPlayer)
		vehicle = getPedOccupiedVehicle(localPlayer)
		currentZone = getZoneName(x,y,z)
		
		if (areaName ~= currentZone) then
			if (vehicle and disabledVehicles[getElementModel(vehicle)]) then
				return
			end
			if (currentZone == "Unknown") then
				if (areaName == "San Andreas") then return end
				currentZone = "San Andreas"
			end
			if (areaName == "") then areaName = currentZone return end

			if tickStart then
				return
			end
			areaName = currentZone
			table.insert( zoneName["currentArea"], areaName )
			
			tickStart = getTickCount()
			if addEventHandler("onClientRender", root, drawZoneName) then
				setElementData(localPlayer, "isZoneNameInScreen", true)
			end
		end
	else
		-- Force Area-name component to hide
		setPlayerHudComponentVisible("area_name", false)
	end
end

function isZoneNameComponentVisible()
	return getElementData(localPlayer, "isZoneNameVisible")
end

function isZoneNameInScreen()
	return getElementData(localPlayer, "isZoneNameInScreen")
end

function setZoneNameComponentVisible( show, showGTAZoneName )
	if (show ~= nil and type(show) == "boolean") then	
	
		local fNamePart = show and "add" or "remove"
		local isVisible = isZoneNameComponentVisible()
		if (show == false and isVisible == false) or (show and isVisible) then
			return false
		end
		
		setElementData(localPlayer, "isZoneNameVisible", show)
		
		if (show == false) then
			setPlayerHudComponentVisible("area_name", (showGTAZoneName or false))
		end
		return _G[ fNamePart.."EventHandler" ]( "onClientRender", root, getCurrentAreaNameOnRender )
	end
	return false
end

local alpha, curAlpha = 255, 255
function textAlpha(eTime)
	if (eTime > timeText+1000) then
		return 0
	end
	
	curAlpha = 255
	if (eTime <= timeText*0.2) then
		curAlpha = eTime*0.255
	elseif (eTime >= timeText) then
		alpha = 255
		curAlpha = alpha - ((eTime - timeText) *0.255)
	end
	
	return curAlpha
end

function drawZoneName()
	if not zoneName["currentArea"][1] then return end
	
	local elapsedTime = getTickCount() - tickStart
	local alpha = textAlpha(elapsedTime)
	
	local x = (sWidth - dxGetTextWidth(zoneName["currentArea"][1],scale,"bankgothic"))
	local width = dxGetTextWidth(zoneName["currentArea"][1],scale,"bankgothic")
	local h = dxGetFontHeight(scale, "bankgothic")
	local y = (sHeight - h) - 4.3 * sHeight/100
	
	drawCustomText( zoneName["currentArea"][1], x, y, width, h+y, tocolor(210, 210, 210, alpha), scale, 1.5, "default-bold", "center" )

	if (alpha == 0) then
		removeEventHandler( "onClientRender", root, drawZoneName )
		setElementData( localPlayer, "isZoneNameInScreen", false )
		elapsedTime, tickStart = nil
		table.remove( zoneName["currentArea"], 1, zoneName["currentArea"][1] )
	end
end

addEventHandler( "setZoneNameVisible:Server", root,
	function( show, showGTAZoneName )
		setZoneNameComponentVisible( show, showGTAZoneName )
	end
)
